#!/bin/bash

DATASET=$1
export HADOOP_CLIENT_OPTS="-Xmx30g $HADOOP_CLIENT_OPTS"

if [ -z $DATASET ]; then
	export DATASET=linkedmdb.lzo
fi
if [ -z $SAMPLER_PROB ]; then
	SAMPLER_PROB=0.000001
	#SAMPLER_PROB=0.001
fi
hdfs dfs -rm -f "datasets/${DATASET}/*.index"
# HDT-MR
sed "s#INPUT_FILE#datasets/${DATASET}#;s#SAMPLER_PROB#${SAMPLER_PROB}#" conf/job-dictionary.xml > ${DATASET}-dictionary.xml
sed "s#INPUT_FILE#datasets/${DATASET}#;s#SAMPLER_PROB#${SAMPLER_PROB}#" conf/job-triples.xml > ${DATASET}-triples.xml
time bash -c "hadoop jar lib/hadoop-lzo-0.4.17.jar com.hadoop.compression.lzo.LzoIndexer datasets/${DATASET}; hadoop jar hdt-mr-2.0.jar -c ${DATASET}-dictionary.xml; hadoop jar hdt-mr-2.0.jar -c ${DATASET}-triples.xml"
