#!/bin/bash

DATASET=$1
export HADOOP_CLIENT_OPTS="-Xmx4096m $HADOOP_CLIENT_OPTS"
if [ -z $NUM_PARTITIONS ]; then
	export NUM_PARTITIONS=200
fi
export NUM_OUTPUT_PARTS=-1

if [ -z $DATASET ]; then
	export DATASET=linkedmdb.lzo
fi
hdfs dfs -rm -f "datasets/${DATASET}/*.index"
time bash -c "hadoop jar lib/hadoop-lzo-0.4.17.jar com.hadoop.compression.lzo.LzoIndexer datasets/${DATASET}; spark-submit --properties-file=conf/spark.conf --jars lib/hadoop-lzo-0.4.17.jar,lib/JLargeArrays-1.6.jar hdt-spark-0.0.1.jar hdfs://hadoop/user/hadoop/datasets/${DATASET} hdfs://hadoop/user/hadoop/spark.job.${DATASET}"

