package com.cbr.hdt.impl;

import java.io.Serializable;
import java.util.Map;

/**
 *
 * @author Carlos Barrales Ruiz
 * <a href="mailto:cbruiz@gmail.com">cbruiz@gmail.com</a>
 */
public class Triple implements Serializable {
    private String subject;
    private String predicate;
    private String object;
    private Long index = 0L;
    private Long sCod = 0L;
    private Long pCod = 0L;
    private Long oCod = 0L;

    /**
     * 
     */
    public Triple() {}
    
    /**
     * Triple constructors
     * @param subject suject
     * @param predicate predicate
     * @param object objet
     */
    public Triple(final String subject, final String predicate, final String object)
    {
        this.subject = subject;
        this.predicate = predicate;
        this.object = object;
    }
    
    /**
     * @return the subject
     */
    public String getSubject() {
        return subject;
    }

    /**
     * @param subject the subject to set
     */
    public void setSubject(String subject) {
        this.subject = subject;
    }

    /**
     * @return the predicate
     */
    public String getPredicate() {
        return predicate;
    }

    /**
     * @param predicate the predicate to set
     */
    public void setPredicate(String predicate) {
        this.predicate = predicate;
    }

    /**
     * @return the object
     */
    public String getObject() {
        return object;
    }

    /**
     * @param object the object to set
     */
    public void setObject(String object) {
        this.object = object;
    }
    
    /**
     * @return the index
     */
    public Long getIndex() {
        return index;
    }

    /**
     * @param index the index to set
     */
    public void setIndex(Long index) {
        this.index = index;
    }
    
    @Override
     public String toString() {
        StringBuilder sb = new StringBuilder();
        if (subject != null) {
            sb.append(subject.toString());
        }
        else {
            sb.append(sCod);
        }
        sb.append(" ");
        if (predicate != null) {
            sb.append(predicate.toString());
        }
        else {
            sb.append(pCod);
        }
        sb.append(" ");
        if (object != null) {
            sb.append(object.toString());
        }
        else {
            sb.append(oCod);
        }
        return sb.toString();
    }

    /**
     * @return the sCod
     */
    public Long getsCod() {
        return sCod;
    }

    /**
     * @param sCod the sCod to set
     */
    public void setsCod(Long sCod) {
        this.sCod = sCod;
    }

    /**
     * @return the pCod
     */
    public Long getpCod() {
        return pCod;
    }

    /**
     * @param pCod the pCod to set
     */
    public void setpCod(Long pCod) {
        this.pCod = pCod;
    }

    /**
     * @return the oCod
     */
    public Long getoCod() {
        return oCod;
    }

    /**
     * @param oCod the oCod to set
     */
    public void setoCod(Long oCod) {
        this.oCod = oCod;
    }

    /**
     *
     * @param smap
     */
    public void encodeSubject(Map<String, Long> smap) {
        this.sCod = smap.get(subject);
        this.subject = null;
    }

    /**
     *
     * @param pmap
     */
    public void encodePredicate(Map<String, Long> pmap) {
        this.pCod = pmap.get(predicate);
        this.predicate = null;
    }
    
    /**
     *
     * @param omap
     */
    public void encodeObject(Map<String, Long> omap) {
        this.oCod = omap.get(object);
        this.object = null;
    }
}
