package com.cbr.hdt.spark;

import org.apache.spark.util.AccumulatorV2;

/**
 *
 * @author Carlos Barrales Ruiz
 * <a href="mailto:cbruiz@gmail.com">cbruiz@gmail.com</a>
 */
public class StatsAccumulator extends AccumulatorV2<Stats, Stats> {
    
    private Stats stats = new Stats();

    @Override
    public boolean isZero() {
        return stats.getCount() == 0;
    }

    @Override
    public AccumulatorV2<Stats, Stats> copy() {
        return new StatsAccumulator();
    }

    @Override
    public void reset() {
        stats = new Stats();
    }

    @Override
    public void add(Stats in) {
        stats.setCount(stats.getCount() + in.getCount());
        stats.setMin(Math.min(stats.getMin(), in.getMin()));
        stats.setMax(Math.max(stats.getMax(), in.getMax()));
    }

    @Override
    public void merge(AccumulatorV2<Stats, Stats> av) {
        add(av.value());
    }

    @Override
    public Stats value() {
        return stats;
    }
    
}
