package org.rdfhdt.hdt.hdt;

import java.io.File;
import java.io.IOException;
import java.io.InputStream;

import org.rdfhdt.hdt.listener.ProgressListener;

/**
 * HDT Operations that are using internally from the implementation.
 * @author mario.arias
 *
 */

public interface HDTPrivate extends HDT {
	/**
	 * Loads a HDT file
	 * 
	 * @param input
	 *            InputStream to read from
     * @param listener
     * @throws java.io.IOException
	 */
	void loadFromHDT(InputStream input, ProgressListener listener) throws IOException;

	/**
	 * Loads a HDT file
	 * 
     * @param fileName
     * @param listener
	 * @param input
	 *            InputStream to read from
     * @throws java.io.IOException
	 */
	void loadFromHDT(String fileName, ProgressListener listener) throws IOException;
	
    /**
     *
     * @param f
     * @param offset
     * @param listener
     * @throws IOException
     */
    void mapFromHDT(File f, long offset, ProgressListener listener) throws IOException;
	
	/**
	 * Generates any additional index needed to solve all triple patterns more efficiently
	 * 
	 * @param listener A listener to be notified of the progress.
	 */
	void loadOrCreateIndex(ProgressListener listener);
	
    /**
     *
     * @param baseUri
     */
    void populateHeaderStructure(String baseUri);
}
