package org.rdfhdt.hdt.triples.impl;

import java.io.File;
import java.io.IOException;
import java.io.InputStream;
import java.io.OutputStream;

import org.rdfhdt.hdt.listener.ProgressListener;
import org.rdfhdt.hdt.util.io.CountInputStream;

/**
 *
 * @author carlos
 */
public interface PredicateIndex {

    /**
     *
     * @param pred
     * @return
     */
    long getNumOcurrences(int pred);

    /**
     *
     * @param pred
     * @param occ
     * @return
     */
    long getOccurrence(int pred, long occ);
	
    /**
     *
     * @param in
     * @throws IOException
     */
    void load(InputStream in) throws IOException;
	
    /**
     *
     * @param in
     * @throws IOException
     */
    void save(OutputStream in) throws IOException;
	
    /**
     *
     * @param input
     * @param f
     * @param listener
     * @throws IOException
     */
    void mapIndex(CountInputStream input, File f, ProgressListener listener) throws IOException;
	
    /**
     *
     * @param listener
     */
    void generate(ProgressListener listener);
}
