library(ggplot2)
ggplot(data=df2, aes(x=dataset, y=time, fill=stage)) + geom_bar(stat="identity")


df <- read.table("results.txt", header=T)

df$Stage = factor(df$Stage, levels=c("Index","Dictionary","Triples","Serialization"), ordered=T)
df$Dataset = factor(df$Dataset, levels=c("linkedmdb","geonames","linkedgeodata","DBPedia", "Freebase"), ordered=T)

ggplot(data=df, aes(x=Method, y=Time, fill=Stage, order=as.numeric(Stage)))+
   geom_bar(stat="identity")+
   facet_wrap(~Dataset,nrow=2)


df <- read.table("results_mashups.txt", header=T)
df$Stage = factor(df$Stage, levels=c("Index","Dictionary","Triples","Serialization"), ordered=T)
df$Dataset = factor(df$Dataset, levels=c("LUBM-4K", "DBPedia+linkedgeodata"), ordered=T)

ggplot(data=df, aes(x=Method, y=Time, fill=Stage, order=as.numeric(Stage)))+
   geom_bar(stat="identity")+
   facet_wrap(~Dataset,nrow=1)